"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.onlineManager = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _subscribable = require("./subscribable");

var _utils = require("./utils");

var OnlineManager = /*#__PURE__*/function (_Subscribable) {
  (0, _inheritsLoose2.default)(OnlineManager, _Subscribable);

  function OnlineManager() {
    return _Subscribable.apply(this, arguments) || this;
  }

  var _proto = OnlineManager.prototype;

  _proto.onSubscribe = function onSubscribe() {
    if (!this.removeHandler) {
      this.setDefaultHandler();
    }
  };

  _proto.setHandler = function setHandler(init) {
    var _this = this;

    if (this.removeHandler) {
      this.removeHandler();
    }

    this.removeHandler = init(function () {
      _this.onOnline();
    });
  };

  _proto.onOnline = function onOnline() {
    this.listeners.forEach(function (listener) {
      listener();
    });
  };

  _proto.isOnline = function isOnline() {
    return navigator.onLine === undefined || navigator.onLine;
  };

  _proto.setDefaultHandler = function setDefaultHandler() {
    var _window;

    if (!_utils.isServer && ((_window = window) == null ? void 0 : _window.addEventListener)) {
      this.setHandler(function (onOnline) {
        // Listen to online
        window.addEventListener('online', onOnline, false);
        return function () {
          // Be sure to unsubscribe if a new handler is set
          window.removeEventListener('online', onOnline);
        };
      });
    }
  };

  return OnlineManager;
}(_subscribable.Subscribable);

var onlineManager = new OnlineManager();
exports.onlineManager = onlineManager;